Index: /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.cpp	(revision 4076)
+++ /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.cpp	(revision 4077)
@@ -44,5 +44,5 @@
     SetRect(&wdgRect,px,py,px+sx,py+sy);
 	cfsrLabel = CFStringCreateWithCString(kCFAllocatorDefault,nom,kCFStringEncodingMacRoman);
-	err = CreateStaticTextControl (wParent, &wdgRect, cfsrLabel, NULL, &viewH);
+	err = CreateStaticTextControl (wParent, &wdgRect, cfsrLabel, NULL, &wdgHIView);
 }
 
@@ -60,5 +60,5 @@
 	// SetPortWindowPort(wParent);
 
-	err = SetControlData (viewH,0,kControlEditTextCFStringTag,sizeof(cfsrLabel),(Ptr)&cfsrLabel);
+	err = SetControlData (wdgHIView,0,kControlEditTextCFStringTag,sizeof(cfsrLabel),(Ptr)&cfsrLabel);
 
 	return;
@@ -94,5 +94,5 @@
 
 	unicodeText = CFStringCreateWithCString (NULL,(char *)s.c_str(), kCFStringEncodingMacRoman);
-	err = CreateEditUnicodeTextControl (wParent,&wdgRect,unicodeText,false,NULL,&viewH);
+	err = CreateEditUnicodeTextControl (wParent,&wdgRect,unicodeText,false,NULL,&wdgHIView);
 
 	return;
@@ -105,5 +105,5 @@
 	char* cText;
 
-	GetControlData(viewH, kControlEditTextPart, kControlEditTextCFStringTag, sizeof(str),&str,NULL);
+	GetControlData(wdgHIView, kControlEditTextPart, kControlEditTextCFStringTag, sizeof(str),&str,NULL);
 	
 	cText = (char *)CFStringGetCStringPtr(str,kCFStringEncodingMacRoman);	
@@ -123,5 +123,5 @@
 {
 	if (te == false)
-		DeactivateControl (viewH);
+		DeactivateControl (wdgHIView);
 
 	return;
@@ -247,8 +247,8 @@
     SetRect(&wdgRect,px,py,px+sx,py+sy);
 
-    CreatePushButtonControl (par->GetWindowRef(),&wdgRect,title,&viewH);
-    SetControlTitleWithCFString (viewH, title);
+    CreatePushButtonControl (par->GetWindowRef(),&wdgRect,title,&wdgHIView);
+    SetControlTitleWithCFString (wdgHIView, title);
 	_actionProc = NewControlActionUPP (CommonControlActionCallback);
-	SetControlAction (viewH, _actionProc);
+	SetControlAction (wdgHIView, _actionProc);
 	vpiwdg.push_back(this);
 }
@@ -267,5 +267,5 @@
 {
     title = CFStringCreateWithCString (NULL, sText.c_str(), kCFStringEncodingMacRoman);
-	SetControlTitleWithCFString(viewH,title);
+	SetControlTitleWithCFString(wdgHIView,title);
 	return;
 }
@@ -281,9 +281,9 @@
 	SetPortWindowPort(wParent);
     SetRect(&wdgRect,px,py,px+sx,py+sy);
-    CreateCheckBoxControl (par->GetWindowRef(),&wdgRect,title,0,TRUE,&viewH);
-    SetControlTitleWithCFString (viewH, title);
+    CreateCheckBoxControl (par->GetWindowRef(),&wdgRect,title,0,TRUE,&wdgHIView);
+    SetControlTitleWithCFString (wdgHIView, title);
 	_actionProc = NewControlActionUPP (CommonControlActionCallback);
-	SetControlAction (viewH, _actionProc);
-	_state = GetControl32BitValue (viewH);
+	SetControlAction (wdgHIView, _actionProc);
+	_state = GetControl32BitValue (wdgHIView);
 
 	vpiwdg.push_back(this);
@@ -303,5 +303,5 @@
 bool PICheckBoxQuartz::GetState()
 {
-	_state = GetControl32BitValue (viewH);
+	_state = GetControl32BitValue (wdgHIView);
 	printf("GetState : %d ",_state);
 	return _state;
@@ -318,8 +318,8 @@
 	SetPortWindowPort(wParent);
     SetRect(&wdgRect,px,py,px+sx,py+sy);
-    CreateRadioButtonControl (par->GetWindowRef(),&wdgRect,title,initialValue,FALSE,&viewH);
-    SetControlTitleWithCFString (viewH, title);
+    CreateRadioButtonControl (par->GetWindowRef(),&wdgRect,title,initialValue,FALSE,&wdgHIView);
+    SetControlTitleWithCFString (wdgHIView, title);
 	_actionProc = NewControlActionUPP (CommonControlActionCallback);
-	SetControlAction (viewH, _actionProc);
+	SetControlAction (wdgHIView, _actionProc);
 	vpiwdg.push_back(this);
 }
@@ -339,5 +339,5 @@
     SetRect(&wdgRect,px,py,px+sx,py+sy);
     OSErr error;
-	error = CreateRadioGroupControl (par->GetWindowRef(),&wdgRect,&viewH);
+	error = CreateRadioGroupControl (par->GetWindowRef(),&wdgRect,&wdgHIView);
 	_state = 0;
 }
@@ -346,5 +346,5 @@
 {
 	OSErr error;
-	error = EmbedControl(piRadio->GetHIViewRef(),viewH);
+	error = EmbedControl(piRadio->GetHIViewRef(),wdgHIView);
 		
 	return;
Index: /trunk/SophyaPI/PI/Quartz/piwdgquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/piwdgquartz.cpp	(revision 4076)
+++ /trunk/SophyaPI/PI/Quartz/piwdgquartz.cpp	(revision 4077)
@@ -16,6 +16,7 @@
     fflush (stdout);
     title = CFStringCreateWithCString (NULL, nom, kCFStringEncodingMacRoman);
-	viewH = NULL;
+	wdgHIView = NULL;
     mFCol = mBCol = PI_NotDefColor;
+//	wdgCGContext = NULL;
 }
 
@@ -243,6 +244,5 @@
     if (contH)
     {
-        InstallControlEventHandler (contH, 
-                                    NewEventHandlerUPP (drwh),
+        InstallControlEventHandler (contH, NewEventHandlerUPP (drwh),
                                     GetEventTypeCount(drawEvents),
                                     drawEvents,
@@ -252,6 +252,5 @@
     if(wPtr)
     {
-        InstallWindowEventHandler (wPtr, 
-                                    NewEventHandlerUPP (drwh),
+        InstallWindowEventHandler (wPtr, NewEventHandlerUPP (drwh),
                                     GetEventTypeCount(drawEvents),
                                     drawEvents,
Index: /trunk/SophyaPI/PI/Quartz/piwdgquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/piwdgquartz.h	(revision 4076)
+++ /trunk/SophyaPI/PI/Quartz/piwdgquartz.h	(revision 4077)
@@ -101,12 +101,16 @@
 	*/
 	
-	HIViewRef GetHIViewRef() {return viewH;}
-
+  inline HIViewRef GetHIViewRef() {return wdgHIView;}
+// pour recuperer Quartz2D Drawing Context
+  // inline CGContextRef GetQuartzCGContext() {return wdgCGContext;}
+  // inline void SetQuartzCGContext(CGContextRef cg) { wdgCGContext = CGContextRetain(cg);}
+  
 protected:
     Rect	wdgRect;
     CFStringRef	title;
-	HIViewRef	viewH;
+	HIViewRef	wdgHIView;
 //  pas utilisable dans MOSX/Carbon
     PIColors mFCol, mBCol;
+//	CGContextRef wdgCGContext;
 };
 
Index: /trunk/SophyaPI/PI/Quartz/sopnamsp.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/sopnamsp.h	(revision 4077)
+++ /trunk/SophyaPI/PI/Quartz/sopnamsp.h	(revision 4077)
@@ -0,0 +1,23 @@
+#ifndef SOPNAMSP_SEEN
+#define SOPNAMSP_SEEN
+
+#ifdef __cplusplus
+
+/*  SOPHYA classes are in namespace SOPHYA:
+ sopnamsp.h :
+   1-/ DOIT etre mis dans les .cc de sophya
+   2-/ NE DOIT JAMAIS etre mis dans un .h de SOPHYA
+       disponible pour les utilisateur exterieurs
+ Dans un main programme:
+   1-/ Si on met sopnamsp.h les classes de SOPHYA
+       doivent etre instanciees: TArray<r_8>
+   2-/ Si on NE met PAS sopnamsp.h les classes de SOPHYA
+       doivent etre instanciees: SOPHYA::TArray<r_8>
+
+*/
+namespace SOPHYA {}
+using namespace SOPHYA;
+
+#endif
+
+#endif
Index: /trunk/SophyaPI/PI/Tests/xp1.cc
===================================================================
--- /trunk/SophyaPI/PI/Tests/xp1.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/Tests/xp1.cc	(revision 4077)
@@ -10,5 +10,5 @@
 #include PISTDWDG_H 
 #include PIWIN_H
-//#include "PIButtonQuartz.h"
+#include "PIButtonQuartz.h"
 
 //  ----- Declaration de la classe ArgsWind : Fenetre de dialogue -------
Index: /trunk/SophyaPI/PI/lut.cc
===================================================================
--- /trunk/SophyaPI/PI/lut.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/lut.cc	(revision 4077)
@@ -12,22 +12,13 @@
 #include "lut.h"
 
-//++
-// Class	LUT
-// Lib		PI
-// include	lut.h
-//
-//	Classe Look-Up table : transformation de valeurs (intensite/RGB) en index de couleur
-//--
-//++
-// Links	Voir aussi
-// PIColorMap
-// PIPixmap
-// PIImage
-//--
+
 /* --Methode-- */
 
-LUT::LUT(double min, double max, unsigned short ncol, int typ) 
+LUT::LUT(double min, double max, unsigned short ncol, int typ, int ntable) 
 {
-int nlev = ncol-2;
+int nlev;
+
+bornes=NULL;
+nlev = ncol-2;
 if (nlev < 1)  nlev = 1;
 bornes = new double[nlev+1];
@@ -35,12 +26,4 @@
 if (bornes == NULL)  return;
 type = typ;  nLevel = nlev;
-int qqq = 1;
-quantum = 1;
-for(quantum=2; quantum<=42; quantum++) {
-  qqq = quantum*quantum*quantum;
-  if (qqq > NCol())  break;
-}
-quantum--;
-
 table = NULL;  
 tablenbin = 0;
@@ -56,45 +39,22 @@
 delete[] table;
 }
-/* --Methode-- */
-void LUT::SetNCol(unsigned short ncol)
-{
-if (ncol == NCol())  return;
-double min = Min();
-double max = Max();
-if (bornes) delete[] bornes;
-int nlev = ncol-2;
-if (nlev < 1)  nlev = 1;
-bornes = new double[nlev+1];
-nLevel = nlev;
-int qqq = 1;
-quantum = 1;
-for(quantum=2; quantum<=42; quantum++) {
-  qqq = quantum*quantum*quantum;
-  if (qqq > NCol())  break;
-}
-quantum--;
-// printf("*DBG*LUT* quantum= %d \n", (int)quantum);
-SetLut(min, max, Type());
-}
 
 /* --Methode-- */
-void LUT::SetLut(double min, double max, int typ)
+void LUT::SetLut(double min, double max, int typ, int ntable)
 {
 
 if(  (typ != kLutType_Lin)  && (typ != kLutType_Log)
-  && (typ != kLutType_Sqrt) && (typ != kLutType_Square)  
-  && (typ != kLutType_RGB) )  typ = kLutType_Lin;
+  && (typ != kLutType_Sqrt) && (typ != kLutType_Square)
+  )  typ = kLutType_Lin;
 type = typ;
 if (max <= min)  max = min+1.;
-mMin = min;  mMax = max;
-mMinI = (int)(min+0.1);  mMaxI = (int)(max+0.1);
 if (nLevel > 0)
   {
   int i;
-  double dx, dlx, fmx;
+  double dx;
+  double dlx;
   switch (typ)
     {
     case kLutType_Lin :
-    case kLutType_RGB :
       dx = (max-min)/(double)nLevel;
       for(i=0; i<nLevel; i++)
@@ -102,13 +62,7 @@
       break;
     case kLutType_Log :
-      fmx = (max-min)/(exp(1.)-1.);
-      dlx = 1./(double)nLevel;
+      dlx = log(max-min) / (double)nLevel;
       for(i=0; i<nLevel; i++)
-        bornes[i] = min+((double)exp((double)i*dlx)-1.)*fmx;
-      break;
-    case kLutType_Exp :
-      dlx = (exp(1.)-1.)/(double)nLevel;
-      for(i=0; i<nLevel; i++)
-        bornes[i] = min+(double)log(1.+(double)i*dlx)*(max-min);
+        bornes[i] = min+(double)exp((double)i*dlx);
       break;
     case kLutType_Sqrt :
@@ -130,6 +84,5 @@
   }
 else  bornes[0] = 0.5*(min+max);
-// ComputeTable((ntable > nLevel) ? ntable : tablenbin);
-if (type != kLutType_RGB) ComputeTable(0);
+ComputeTable((ntable > nLevel) ? ntable : tablenbin);
 return; 
 }
@@ -148,5 +101,5 @@
 
 /* --Methode-- */
-unsigned short LUT::ApplyI(double x)
+unsigned short LUT::Apply(double x)
 {
 int i;
@@ -157,32 +110,12 @@
 
 /* --Methode-- */
-unsigned short LUT::ApplyRGB(double x)
-{
-  long lv = x+0.3;
-  int r = (lv%256);
-  lv /= 256;
-  int g = (lv%256);
-  lv /= 256;
-  int b = (lv%256);
-  return (unsigned short)((Contraste(b)*quantum+Contraste(g))*quantum+Contraste(r));
-}
-
-/* --Methode-- */
 void LUT::ComputeTable(int nt)
 {
-if (nt <= 0) { 
-  int fm = 16;
-  if ((nLevel+2)>4096) fm = 1;
-  else if ((nLevel+2)>2048) fm = 2;
-  else if ((nLevel+2)>1024) fm = 4;
-  else if ((nLevel+2)>512) fm = 8;
-  nt = fm*(nLevel+2);
-}
+if (nt <= 0) nt = 16*(nLevel+2);
 else if (nt < (nLevel+2))  nt = (nLevel+2);
 tablenbin = nt;
-if (table) delete[] table;
 table = new unsigned short [nt-2];
 tablebinwidth = (Max()-Min())/(nt-2);
 double x = Min()+0.5*tablebinwidth;
-for(int i=0; i<nt-2; i++)  { table[i] = ApplyI(x); x += tablebinwidth; }
+for(int i=0; i<nt-2; i++)  { table[i] = Apply(x); x += tablebinwidth; }
 }
Index: /trunk/SophyaPI/PI/lut.h
===================================================================
--- /trunk/SophyaPI/PI/lut.h	(revision 4076)
+++ /trunk/SophyaPI/PI/lut.h	(revision 4077)
@@ -13,5 +13,5 @@
 
 // Type de lut possibles 
-enum {kLutType_Lin=1, kLutType_Log=2, kLutType_Exp=3, kLutType_Sqrt=4, kLutType_Square=5, kLutType_RGB=11 };
+enum {kLutType_Lin=1, kLutType_Log=2, kLutType_Sqrt=3, kLutType_Square=4};
 
 class LUT 
@@ -19,36 +19,11 @@
 public:
   
-  LUT(double min, double max, unsigned short ncol=16, int typ=kLutType_Lin);
+  LUT(double min, double max, unsigned short ncol=16, int typ=kLutType_Lin, int ntable=0);
   ~LUT();
-  void SetNCol(unsigned short ncol);
-  void SetLut(double min, double max, int typ=kLutType_Lin);
+  void SetLut(double min, double max, int typ=kLutType_Lin, int ntable=0);
   void Print();
-
-  inline unsigned short Apply(double x)
-    { 
-    if (type == kLutType_RGB) return ApplyRGB(x); 
-    else return ApplyI(x);	
-    } 
-
+  unsigned short Apply(double x);
   inline unsigned short ApplyFast(double x)
     { 
-    if (type == kLutType_RGB) return ApplyRGB(x); 
-    else return AppFast(x);	
-    } 
-
-
-  inline double Min() { return(bornes[0]); };
-  inline double Max() { return(bornes[nLevel]); };
-  inline double Borne(int k) { return(bornes[k]); };
-  inline int Type() { return(type); };
-  inline int NCol() { return(nLevel+2); };
-
-
-protected:
-  void ComputeTable(int nt);
-  unsigned short ApplyI(double x);
-  unsigned short ApplyRGB(double x);
-  inline unsigned short AppFast(double x)
-    {
     if (x < Min())  return(0);
     if (x >= Max() )  return(nLevel+1);  
@@ -56,16 +31,16 @@
     return(table[k]); 
     } 
-  inline int  Contraste(int ii)   /* for ApplyRGB */
-    {
-    if (ii >= mMaxI) return quantum-1;
-    if (ii <= mMinI) return 0;
-    else return ((ii-mMinI)*(quantum-1)/mMaxI);
-    }	  
+
+  inline double Min() { return(bornes[0]); };
+  inline double Max() { return(bornes[nLevel]); };
+  inline int Type() { return(type); };
+  inline int NCol() { return(nLevel+2); };
+
+protected:
+  void ComputeTable(int nt);
+
   int type;
   int nLevel;
-  int quantum;
   double * bornes;
-  double mMin, mMax;
-  int mMinI, mMaxI;
   int tablenbin;
   unsigned short * table;
Index: /trunk/SophyaPI/PI/objlist.list
===================================================================
--- /trunk/SophyaPI/PI/objlist.list	(revision 4076)
+++ /trunk/SophyaPI/PI/objlist.list	(revision 4077)
@@ -48,5 +48,4 @@
 pipixmapgen.o
 pipixmapx.o
-pipixutils.o
 piscdrawwdg.o
 pistdwdggen.o
Index: /trunk/SophyaPI/PI/parradapter.cc
===================================================================
--- /trunk/SophyaPI/PI/parradapter.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/parradapter.cc	(revision 4077)
@@ -174,19 +174,4 @@
 
 /* --Methode-- */
-double  P2DArrayAdapter::MeanVal(int ix1, int ix2, int jy1, int jy2)
-{
-int ec;
-if (ix1>ix2) { ec=ix1; ix1=ix2; ix2=ec; }
-if (jy1>jy2) { ec=jy1; jy1=jy2; jy2=ec; }    
-// On calcule la somme des pixels dans la zone
-double ss = 0.;
-for(int j=jy1; j<=jy2; j++) 
-  for(int i=ix1; i<=ix2; i++)  ss += Value(i,j);
-
-ss /= (double)((jy2-jy1+1)*(ix2-ix1+1));
-return ss;  
-}   
-
-/* --Methode-- */
 void P2DArrayAdapter::XYfromxy(int ix, int iy, double& x, double& y)
 {
@@ -202,5 +187,5 @@
   double x,y;
   this->Coord(ix, iy, x, y);
-  const char * isr = "";
+  char * isr = "";
   if (ISFunc != NULL)  isr = ISFunc(this, ix, iy);
   sprintf(ibuff,"X= %g Y= %g  Pix= %g %s   ", 
@@ -448,11 +433,13 @@
 
 /* --Methode-- */
-void P2DArrayAdapter::ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
-                                    int xwsz, int ywsz, PIPixColIdx & pixc)
+unsigned char * P2DArrayAdapter::ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
+                int xwsz, int ywsz, unsigned char * opix, int * oxsp, int * oysp)
 {
 // TIMEF ; 
+unsigned char *pix, *pp, ucp;
 int zmm=1;
-int npx, npy, nppx, nppy;
+int npx, npy, nppx, nppy, nszp, oszp;
 int i,j,k,l;
+double vpx;
 
 /*
@@ -461,7 +448,6 @@
 */
 
-if ( (XSize() <= 0) || (YSize() <= 0) || (lut == NULL) || (ofx < 0) || (ofy < 0) ) {
-  pixc.DeAlloc();  return; 
-}
+if ( (XSize() <= 0) || (YSize() <= 0) || (lut == NULL) || (ofx < 0) || (ofy < 0) ) 
+  { *oxsp = *oysp = 0; return(NULL); }
 
 npx = XSize()-ofx;
@@ -485,18 +471,21 @@
   }
 
-
-/* printf("Debug_ComputePixmap %d %d %d (%d-%d %d-%d)\n", 
-      ofx, ofy, zm, npx,nppx, npy,nppy); */
-if (lut->NCol() <= 256) {  // On fait un pixmap de type Byte/pixel 
+oszp = (*oxsp)*(*oysp);
+nszp = nppx*nppy;
+if ( oszp != nszp )
+  {
+  if (opix)  delete[] opix;
+  pix = new unsigned char[nppx*nppy];
+  if (pix == NULL)  { *oxsp = *oysp = 0; ; return(NULL); }
+  }
+else  pix = opix;
+*oxsp = nppx; *oysp = nppy;
+
 /*
-printf("Debug_ComputePixmap- pixc.AllocateByte() type=%d - %d %d %d - %d %d %d - %d %d %d \n",
-  lut->Type(), 
-  lut->ApplyFast(0.), lut->ApplyFast(1.), lut->ApplyFast(2.), 
-  lut->ApplyRGB(0.), lut->ApplyRGB(1.), lut->ApplyRGB(2.), 
-  lut->Apply(0.), lut->Apply(1.), lut->Apply(2.));
-*/  
-unsigned char *pp, ucp;
-pixc.AllocateByte(nppx, nppy);
-pp = pixc.BytePointer();
+printf("Debug_ComputePixmap %d %d %d (%d-%d %d-%d)\n", 
+      ofx, ofy, zm, npx,nppx, npy,nppy);
+*/
+
+pp = pix;
 if (eXY) { // Echange Axe X,Y 
   if (zm == 1)  {  // Pas de zoom  
@@ -508,10 +497,14 @@
     }
   else if (zm < -1) {       // Compression 
+    double fv = (double)(zmm*zmm); 
     for(j=ofy; j<ofy+npy; j+=zmm)
-      for(i=ofx; i<ofx+npx; i+=zmm) { 
-        *pp = lut->ApplyFast( MeanVal(j*sgnX+offX, (j+zmm-1)*sgnX+offX, 
-                                      i*sgnY+offY, (i+zmm-1)*sgnY+offY) );
+      for(i=ofx; i<ofx+npx; i+=zmm) {
+        vpx = 0;
+        for(l=0; l<zmm; l++)
+          for(k=0; k<zmm; k++)
+            vpx += this->Value( (j+l)*sgnX+offX, (i+k)*sgnY+offY);
+        *pp = (unsigned char) lut->ApplyFast(vpx/fv); 
         pp++;
-      }
+        }
     }
   else  {      // Agrandissement
@@ -520,5 +513,5 @@
         ucp = (unsigned char) lut->ApplyFast(this->Value(j*sgnX+offX, i*sgnY+offY));
         for(l=0; l<zm; l++)  {
-          pp = pixc.BytePointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
+          pp = pix+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
           for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
 	  }
@@ -535,10 +528,14 @@
     }
   else if (zm < -1) {       // Compression 
+    double fv = (double)(zmm*zmm); 
     for(j=ofy; j<ofy+npy; j+=zmm)
       for(i=ofx; i<ofx+npx; i+=zmm) {
-        *pp = lut->ApplyFast( MeanVal(i*sgnX+offX, (i+zmm-1)*sgnX+offX, 
-                                      j*sgnY+offY, (j+zmm-1)*sgnY+offY) );
+        vpx = 0;
+        for(l=0; l<zmm; l++)
+          for(k=0; k<zmm; k++)
+            vpx += this->Value( (i+k)*sgnX+offX, (j+l)*sgnY+offY);
+        *pp = (unsigned char) lut->ApplyFast(vpx/fv); 
         pp++;
-      }
+        }
     }
   else  {      // Agrandissement
@@ -547,5 +544,5 @@
         ucp = (unsigned char) lut->ApplyFast(this->Value(i*sgnX+offX, j*sgnY+offY));
         for(l=0; l<zm; l++)  {
-          pp = pixc.BytePointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
+          pp = pix+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
           for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
 	  }
@@ -553,65 +550,5 @@
     }
   }
-}  //  ---- Fin pixmap de type Byte
-else {  // On fait un pixmap de type short/pixel 
-// printf("Debug_ComputePixmap- pixc.AllocateShort() \n");
-unsigned short *pp, ucp;
-pixc.AllocateShort(nppx, nppy);
-pp = pixc.ShortPointer();
-if (eXY) { // Echange Axe X,Y 
-  if (zm == 1)  {  // Pas de zoom  
-    for(j=ofy; j<ofy+npy; j++)
-      for(i=ofx; i<ofx+npx; i++) {
-        *pp = lut->ApplyFast(this->Value(j*sgnX+offX, i*sgnY+offY));  pp++; 
-      }
-    }
-  else if (zm < -1) {       // Compression 
-    for(j=ofy; j<ofy+npy; j+=zmm)
-      for(i=ofx; i<ofx+npx; i+=zmm) { 
-        *pp = lut->ApplyFast( MeanVal(j*sgnX+offX, (j+zmm-1)*sgnX+offX, 
-                                      i*sgnY+offY, (i+zmm-1)*sgnY+offY) );
-        pp++;
-      }
-    }
-  else  {      // Agrandissement
-    for(j=ofy; j<ofy+npy; j++)
-      for(i=ofx; i<ofx+npx; i++)  {
-        ucp = lut->ApplyFast(this->Value(j*sgnX+offX, i*sgnY+offY));
-        for(l=0; l<zm; l++)  {
-          pp = pixc.ShortPointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
-          for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
-	  }
-        }
-    }
-  }     // Fin du cas avec echange d'axe X/Y 
-else {
-  if (zm == 1)  {  // Pas de zoom  
-    for(j=ofy; j<ofy+npy; j++)
-      for(i=ofx; i<ofx+npx; i++) {
-        *pp = lut->ApplyFast(this->Value(i*sgnX+offX, j*sgnY+offY));  pp++; 
-      }
-    }
-  else if (zm < -1) {       // Compression 
-    for(j=ofy; j<ofy+npy; j+=zmm)
-      for(i=ofx; i<ofx+npx; i+=zmm) {
-        *pp = lut->ApplyFast( MeanVal(i*sgnX+offX, (i+zmm-1)*sgnX+offX, 
-                                      j*sgnY+offY, (j+zmm-1)*sgnY+offY) );
-        pp++;
-      }
-    }
-  else  {      // Agrandissement
-    for(j=ofy; j<ofy+npy; j++)
-      for(i=ofx; i<ofx+npx; i++)  {
-        ucp = lut->ApplyFast(this->Value(i*sgnX+offX, j*sgnY+offY));
-        for(l=0; l<zm; l++)  {
-          pp = pixc.ShortPointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
-          for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
-	  }
-        }
-    }
-  }
-}  //  ---- Fin pixmap de type Byte
-
-return;
+return(pix);
 }
 
Index: /trunk/SophyaPI/PI/parradapter.h
===================================================================
--- /trunk/SophyaPI/PI/parradapter.h	(revision 4076)
+++ /trunk/SophyaPI/PI/parradapter.h	(revision 4077)
@@ -9,5 +9,4 @@
 #include "machdefs.h"
 #include "lut.h"
-#include "pipixutils.h"
 
 #include <string> 
@@ -55,7 +54,5 @@
   virtual void    DefineXYCoordinates(double x0, double y0, double dx, double dy);
 // Doit etre defini par les classes derivees
-  virtual double  Value(int ix, int iy) = 0;
-// Peut etre redefini pour les classes derivees, pour une optimisation par exemple     
-  virtual double  MeanVal(int ix1, int ix2, int jy1, int jy2);   
+  virtual double  Value(int ix, int iy) = 0;   
 
   virtual void    XYfromxy(int ix, int iy, double& x, double& y);
@@ -92,6 +89,7 @@
 
 //    Calcul pixmap avec un LUT
-  virtual void ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
-                             int xwsz, int ywsz, PIPixColIdx & pixc);
+  virtual unsigned char * ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
+                           int xwsz, int ywsz, unsigned char * opix, 
+                           int * oxsp, int * oysp);
 
 //   Methode de decodage des options - Implementation par defaut ne fait rien
@@ -110,6 +108,4 @@
 
 };
-
-//  Adaptateur de tableau 1D pour pointeur de type T *
 
 template <class T> 
@@ -130,5 +126,4 @@
 
 
-//  Adaptateur de tableau 2D pour pointeur de type T *
 template <class T> 
 class P2DAdapter : public P2DArrayAdapter {
@@ -139,19 +134,7 @@
 
   virtual 	  ~P2DAdapter() { if ( (aDel) && (mData) ) delete[] mData; }
-  virtual double  Value(int ix, int iy) 
+  virtual double   Value(int ix, int iy) 
                     {  if ( (ix < 0)  || (iy < 0) || (ix >= sX) || (iy >= sY) ) return(0.); 
                     return(mData[ix+iy*sX]); }
-  virtual double  MeanVal(int ix1, int ix2, int jy1, int jy2)  
-    {
-    int ec;
-    if (ix1>ix2) { ec=ix1; ix1=ix2; ix2=ec; }
-    if (jy1>jy2) { ec=jy1; jy1=jy2; jy2=ec; }    
-    double ss = 0.;
-    for(int j=jy1; j<=jy2; j++) 
-      for(int i=ix1; i<=ix2; i++)  ss += (double)(mData[i+j*sX]);
-    ss /= (double)((jy2-jy1+1)*(ix2-ix1+1));
-    return ss;  
-    }   
-
 protected :
   bool aDel;
@@ -159,42 +142,4 @@
 };
 
-//  Adaptateur de tableau 2D pour tableau RGB 
-
-class P2DPixRGBAdapter : public P2DArrayAdapter {
-public :
-          P2DPixRGBAdapter(PIPixRGBArray * rgbp, bool ad=false) :
-             P2DArrayAdapter(rgbp->XSize(), rgbp->YSize() )
-                { aDel = ad; mPix = rgbp; }
-  virtual ~P2DPixRGBAdapter() { if ( (aDel) && (mPix) ) delete mPix; }
-
-  virtual double  Value(int ix, int iy) 
-    {  
-    if ( (ix < 0)  || (iy < 0) || (ix >= sX) || (iy >= sY) ) return(0.); 
-    PIPixRGB rgb = (*mPix)(ix, iy);
-    return ( ((double)rgb.blue*256.+(double)rgb.green)*256.+(double)rgb.red );
-    }
-  virtual double  MeanVal(int ix1, int ix2, int jy1, int jy2)  
-    {
-    int ec;
-    if (ix1>ix2) { ec=ix1; ix1=ix2; ix2=ec; }
-    if (jy1>jy2) { ec=jy1; jy1=jy2; jy2=ec; }    
-    int r = 0;
-    int g = 0;
-    int b = 0;
-    for(int j=jy1; j<=jy2; j++) 
-      for(int i=ix1; i<=ix2; i++)  {
-      	PIPixRGB rgb = (*mPix)(i, j);
-      	r += rgb.red;  g += rgb.green;   b += rgb.blue; 
-      }
-    int n = (jy2-jy1+1)*(ix2-ix1+1);   
-    r /= n; g /= n; b /= n;
-    return ( ((double)b*256.+(double)g)*256.+(double)r );  
-    }   
-                    
-protected :
-  bool aDel;
-  PIPixRGBArray* mPix;
-};
-
 
 
Index: /trunk/SophyaPI/PI/pi3dwdg.cc
===================================================================
--- /trunk/SophyaPI/PI/pi3dwdg.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/pi3dwdg.cc	(revision 4077)
@@ -224,6 +224,6 @@
   double ymin = mBDrw->ScaleY( mBDrw->YMin3() );
   double ymax = mBDrw->ScaleY( mBDrw->YMax3() );
-  double zmin = mBDrw->ScaleZ( mBDrw->ZMin3() );
-  double zmax = mBDrw->ScaleZ( mBDrw->ZMax3() );
+  double zmin = mBDrw->ScaleY( mBDrw->ZMin3() );
+  double zmax = mBDrw->ScaleY( mBDrw->ZMax3() );
   bool asxy = mBDrw->isAutoScaleXY();
   bool asz = mBDrw->isAutoScaleZ();
Index: /trunk/SophyaPI/PI/piapplgen.cc
===================================================================
--- /trunk/SophyaPI/PI/piapplgen.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/piapplgen.cc	(revision 4077)
@@ -54,7 +54,4 @@
 #include "sopnamsp.h"
 #include "piapplgen.h"
-#include <stdlib.h>
-#include <iostream>
-#include "pidrawer.h"
 
 // Variable qui contient le pointeur de l'application courante
@@ -65,17 +62,5 @@
 :topcont(NULL), menubar(NULL), mState(0)
 {
-  curapp = this;   
-// Si la variable d'environnement PIDEFAFSZFRAC est definie, on modifie 
-// la taille par defaut de AutoFontSizeFrac
-  char *envafsz = getenv("PIDEFAFSZFRAC");
-  if (envafsz) {
-    double fsfr = atof(envafsz);
-    if ((fsfr>0.)&&(fsfr<1.)) {
-      PIDrawer::SetGlDefAutoFontSizeFrac(fsfr);
-      cout << " PIApplicationGen()/Info: getenv(PIDEFAFSZFRAC)=" << envafsz << endl;
-      cout << "  ... Set Global Default PIDrawer AutoFontSizeFrac to " 
-           << PIDrawer::GetGlDefAutoFontSizeFrac() << endl;
-      }
-  }
+curapp = this;   
 }
 
Index: /trunk/SophyaPI/PI/piapplx.cc
===================================================================
--- /trunk/SophyaPI/PI/piapplx.cc	(revision 4076)
+++ /trunk/SophyaPI/PI/piapplx.cc	(revision 4077)
@@ -1,2 +1,5 @@
+#ifndef __PIWQUARTZ__
+#ifndef __MWERKS__ 
+
 #include <stdio.h>
 #include <X11/cursorfont.h>
@@ -40,5 +43,5 @@
 class PITopContAppX : public PIContainer {
 public :
-	    	PITopContAppX(PIContainer *par, const char *nom, PIWdg* topw,
+	    	PITopContAppX(PIContainer *par, char *nom, PIWdg* topw,
                           int sx=10, int sy=10, int px=0, int py=0);
    virtual  	~PITopContAppX(); 
@@ -52,5 +55,5 @@
 
 /* --Methode-- */
-PITopContAppX::PITopContAppX(PIContainer *par, const char *nom, PIWdg* topw, int sx, int sy, int px, int py)
+PITopContAppX::PITopContAppX(PIContainer *par, char *nom, PIWdg* topw, int sx, int sy, int px, int py)
         : PIContainer(par, nom, (sx>10)?sx:10, (sy>10)?sy:10, px, py)
 {
@@ -141,5 +144,6 @@
 if (sx < sxt)  sx = sxt;
 if (sy < 10) sy = 10;
-topcont = new PITopContAppX(MBCont(), "TopLevelCont", topwdg, sx, sy, 0, msy);
+topcont = new PITopContAppX(MBCont(), "TopLevelCont", topwdg, 
+                            sx, sy, 0, msy);
 MBCont()->Show();
 //DBG printf("PIApplicationX-DBG2:: MBContSize=%d %d \n", MBCont()->XSize(), MBCont()->YSize());
@@ -531,2 +535,5 @@
 }
 
+#endif
+#endif
+
